$(document).ready(function () {
	initMultipleChoice();
	var p = parseQueryString(location.search);
	var maxWrongAnsw;
	var wrongAnsw;
	var Smc = {};
	Smc.Scorm = {};

	if (p["highlight"]){
		$("#section-column-main-content").SearchHighlight({
			exact: "partial",
			style_name: "highlight",
			style_name_suffix: false,
			keys: p["highlight"],
			highlight: "#section-column-main-content"
		});
	}

	$(this).on("click", ".isSubsection", function () {
		var linkId = this.getAttribute("id");
		linkId = linkId.substring(linkId.indexOf("_") + 1)
		var linkTarget = $("#"+linkId);
		var activeLinks = [];
		if(linkTarget[0]){
			$(this).parents("li").each(function (){
				activeLinks.push($(this).children("a")[0].getAttribute("id"));
				if(!$(this).hasClass("active")){
					$(this).addClass("active");
				}
			});
			$(".navigation li.active").each(function () {
				var currentLinkId = $(this).children("a")[0].getAttribute("id");
				if(!activeLinks.includes(currentLinkId)){
					$(this).removeClass("active");
				}
			});
		}
	});

	$(this).on("click", ".collapsibleHeader", function () {
		var bockCt = $(this).closest(".collapsible")[0];
		if($(bockCt).hasClass("closed")){
			$(bockCt).removeClass("closed");
		}else{
			$(bockCt).addClass("closed");
		}
	});

	// validation to avoid execution this fragment of when code is online externally
	if (document.online !== true) {
		var startupHash = window.location.hash;
		if (startupHash && startupHash.indexOf("#") > -1) {
			startupHash = startupHash.substring(startupHash.indexOf("#") + 1);
			var navToHash = $("#nav_" + startupHash);
			if (navToHash.length > 0) {
				$(navToHash).parents("li").each(function () {
					if (!$(this).hasClass("active")) {
						$(this).addClass("active");
					}
				});
			}
		}
	}
		
	function parseQueryString(queryString) {
		var params = new Object();
		if (queryString == null)
			return params;
		if (queryString.substring(0, 1) == "?")
			queryString = queryString.substring(1);

		var paramsArr = queryString.split("&");
		for (var i = 0; i < paramsArr.length; i++)
		{
			var item = paramsArr[i];
			var pos = item.indexOf("=");
			if (pos > -1)
			{
				var arr = item.split("=");
				params[arr[0]] = decodeURIComponent(arr[1]);
			}
			else
				params[item] = "";
		}
		return params;
	};

	function setCookie(cname, cvalue, exdays) {
		var d = new Date();
		d.setTime(d.getTime() + (exdays * 24 * 60 * 60 * 1000));
		var expires = "expires="+d.toUTCString();
		document.cookie = cname + "=" + cvalue + ";path=/;" + expires + ";";
	}

	function getCookie(cName) {
		var name = cName + "=";
		var ca = document.cookie.split(';');
		for(var i = 0; i < ca.length; i++) {
			var c = ca[i];
			while (c.charAt(0) == ' ') {
				c = c.substring(1);
			}
			if (c.indexOf(name) == 0) {
				return c.substring(name.length, c.length);
			}
		}
		return "";
	}

	window.addEventListener("message", receiveMessage, false);
	function receiveMessage(event) {
		if (event.data === 'print') {
			window.print();
		}
	}
	window.onafterprint = function () {
		window.close();
	};

	// validation to avoid execution this fragment of when code is online externally
	if (document.online !== true) {
		$(this).on("click", ".actionButtonCopy", function (event) {
			buttonActionCopy(event);
			$('body').append('<div class="alert alert-success collapse" id="copyAlert" role="alert" data-dismiss="alert">Text copied</div>');
			$('#copyAlert').show('fade');
			setTimeout(function () {
				$('#copyAlert').hide('fade');
				$('#copyAlert').remove();
			}, 1000)
		});
	}

	var buttonActionCopy = function (event) {

		event.preventDefault();

		var copyButton = event.target.nextSibling;

		if (window.getSelection) {
			if (window.getSelection().empty) { // Chrome
				window.getSelection().empty();
			} else if (window.getSelection().removeAllRanges) { // Firefox
				window.getSelection().removeAllRanges();
			}
		} else if (document.selection) { // IE?
			document.selection.empty();
		}

		if (document.selection) {
			var range = document.body.createTextRange();
			if ($(copyButton).is(":visible")) {
				range.moveToElementText(copyButton);
				range.select().createTextRange();
				document.execCommand("copy");
			} else {
				$(copyButton).show();
				range.moveToElementText(copyButton);
				range.select().createTextRange();
				document.execCommand("copy");
				$(copyButton).hide();
			}
		} else if (window.getSelection) {
			var range = document.createRange();
			if ($(copyButton).is(":visible")) {
				range.selectNode(copyButton);
				window.getSelection().addRange(range);
				document.execCommand("copy");
			} else {
				$(copyButton).show();
				range.selectNode(copyButton);
				window.getSelection().addRange(range);
				document.execCommand("copy");
				$(copyButton).hide();
			}
		}

		window.getSelection().removeAllRanges();


	}
	$('.timer_modal').on('hidden.bs.modal', function () {
		var clock = $(this).data('clock');
		var blockType = clock.data('blockType');
		var blockId = clock.data('blockId');

		if(clock.length){
			var clockCt = clock.parent();
			var testCt = $("#"+blockId);
			var blockHeader = $(testCt).find("header");
			if(blockHeader.length > 0){
				$(clockCt).detach().insertAfter(blockHeader);
			}else{
				$(clockCt).detach().prependTo(testCt);
			}

			clockCt.show();
			if(blockType=="test"){
				clock.children(".countDownCt").countdown({until: $(this).data("countDownTimer"),format:'MS',layout: '{mnn}{sep}{snn}',onExpiry: function(){
						timeOff(clock);
					}});
				window.isTesting = true;
			}else{
				clock.children(".countDownCt").countdown({since: $(this).data("countDownTimer"),format:'MS',layout: '{mnn}{sep}{snn}'});
			}
			clock.addClass("play");
			$("#"+blockId+"-cover-ct").hide();
			$(this).data('executed',true);
		}
	});
	$('.question_modal').on('hidden.bs.modal', function () {
		var clock = $(this).data('clock');
		var blockType = clock.data('blockType');
		var blockId = clock.data('blockId');

		if(clock.length){
			clock.show();
			if(blockType=="test"){
				clock.children(".countDownCt").countdown({until: $(this).data("countDownTimer"),format:'MS',layout: '{mnn}{sep}{snn}',onExpiry: function(){
						timeOff(clock);
					}});
				window.isTesting = true;
			}else{
				clock.children(".countDownCt").countdown({since: $(this).data("countDownTimer"),format:'MS',layout: '{mnn}{sep}{snn}'});
			}
			clock.addClass("play");
			$("#"+blockId+"-cover-ct").hide();
			$(this).data('executed',true);
		}
	});

	function checkTimer(blockId, moveClock, topDistance) {
		var panel = $("#"+blockId);
		var useTimer = panel.data('useTimer');
		var blockType = panel.data('blockType');
		var maxTime = panel.data('maxTime');
		var wrongTrials = panel.data('wrongTrials');
		var grade = panel.data('grade');
		var clock = $('#clock');
		clock.parent().hide();
		clock.data("testObject",null);
		clock.data("blockId",blockId);
		clock.data("blockType",blockType);
		clock.data("wrongTrials",wrongTrials);
		clock.data("grade",grade);
		var countDownCt = clock.children(".countDownCt");
		if (countDownCt && countDownCt.countdown) {
			countDownCt.countdown('destroy');
		}
		clock.removeClass("block-training");
		clock.removeClass("block-test");
		clock.removeClass("stopped");
		clock.addClass("block-"+blockType);

		var currentDate = new Date();
		var countModal = $("#"+blockId+"-timer-modal");
		if (typeof SCOasBrowse !== 'undefined' && SCOasBrowse()){
			countModal.data('executed',true);
		}
		var animationExecuted = countModal.data('executed');

		if(useTimer && !animationExecuted){
			$("#"+blockId+"-show-time").html(maxTime);
			var countDownTimer = panel.data('countDownTimer');
			countModal.data("clock",clock);
			countModal.data("countDownTimer",countDownTimer);
			countModal.modal("show");
			$("#"+blockId+"-cover-ct").show();
			/*if(moveClock)
				clock.css('top',topDistance + 'px')*/
		}else if(useTimer && animationExecuted){
			$("#"+blockId+"-cover-ct").show();
		}else{
			$("#"+blockId+"-cover-ct").hide();
		}
	};

	$('.radioLabel').click(function(e){
		e.preventDefault();
		var inputID = $(this).attr("for");
		var inputElem = $('#'+inputID);
		if (inputElem[0].checked == true) {
			inputElem[0].checked = false;
		} else {
			inputElem[0].checked = true;
		}
	});

	function getSummary(){
		var testState = getCookie('testState');
		//alert('Sumary!');
		var summaryPanels = $(".feedbackSummary");
		for (var i = 0; i < summaryPanels.length; i++) {
			var summary = summaryPanels[i];
			var currentFeedback = null;
			var feedbackDefault = $(summary).find(".feedback[data-is-default='true']")[0];


			var feedbacks = $(summary).children(".feedback[data-is-default!='true']");
			var totalWrongs = testState;

			for (var i = 0; i < feedbacks.length; i++) {
				var feedback = feedbacks[i];
				var currentWrongs = $(currentFeedback).data("wrongTrials") ? $(currentFeedback).data("wrongTrials") : null;
				if($(feedback).data("wrongTrials") >= totalWrongs && (currentWrongs == null || $(feedback).data("wrongTrials") <= currentWrongs) ){
					currentFeedback = feedback;
					if ($(feedback).data("wrongTrials") === totalWrongs) {
						break;
					}
				}
			}

			if(currentFeedback != null){
				$(currentFeedback).show();
			}else if(feedbackDefault != null){
				$(feedbackDefault).show();
			}

		}

	}

	Smc.Scorm.interactionEnd = function(testObject){
		var clock = $('#clock');
		clock.data("testObject",testObject);
		var wrongTrials = clock.data("wrongTrials");
		var totalWrong = wrongTrials && testObject.errorCount == wrongTrials;
		if((testObject.finished || totalWrong) ||
			(testObject.excerciseFinished && testObject.finished)
		){
			Smc.Scorm.showFeedback(clock);

			if (!testObject.excerciseFinished){
				// if break simulation (testObject.errorCount == wrongTrials)
				Smc.Scorm.setScormScore(clock);
			}
		}
		if(testObject.excerciseFinished){
			clock.children(".countDownCt").countdown('pause');
			clock.addClass("stopped");
			Smc.Scorm.setScormScore(clock);
			window.isTesting = false;
		}
	}

	Smc.Scorm.showFeedback = function (clock, timeOff) {
		window.isTesting = false;
		clock.children(".countDownCt").countdown('pause');
		clock.addClass("stopped");
		var blockId = clock.data('blockId');
		var panel = $("#" + blockId);
		$("#"+blockId+"-cover-ct").show();
		var currentFeedback = null;
		var feedbackDefault = panel.find(".feedback[data-is-default='true']")[0];
		var feedbackTimeOff = panel.find(".feedback[data-if-timeoff='true']")[0];
		var testObject = clock.data("testObject");
		var blockType = clock.data('blockType');
		var feedbackModal = $("#"+blockId+"-modal-feedback");

		var parentBlock = panel.parents("*[data-block-id='"+blockId+"']");

		if(testObject != null){
			var feedbacks = panel.children(".feedback[data-is-default!='true'][data-if-timeoff!='true']");
			var totalWrongs = testObject.errorCount;

			if(!testObject.aproved)
				saveTestState();

			for (var i = 0; i < feedbacks.length; i++) {
				var feedback = feedbacks[i];
				var currentWrongs = $(currentFeedback).data("wrongTrials") ? $(currentFeedback).data("wrongTrials") : null;
				if($(feedback).data("wrongTrials") >= totalWrongs && (currentWrongs == null || $(feedback).data("wrongTrials") <= currentWrongs) ){
					currentFeedback = feedback;
					if ($(feedback).data("wrongTrials") === totalWrongs) {
						break;
					}
				}
			}
		}

		if(timeOff)
			saveTestState();

		if(!timeOff){
			if(currentFeedback != null){
				Smc.Scorm.showFeedback(currentFeedback);
			}else if(feedbackDefault != undefined){
				showFeedBack(feedbackDefault);
			}
		}else if(feedbackTimeOff != undefined ){
			Smc.Scorm.showFeedback(feedbackTimeOff);
		}
		function showFeedBack(feedBack){
			$("#"+blockId+"-feedback-msg").html($(feedBack).html());

			var button = $("#"+blockId+"-button-test-reload");
			button.click(function() {
				window.location.reload(false);
			});
			$(button).detach().appendTo("#"+blockId+"-feedback-msg");

			feedbackModal.modal("show");

			if(parentBlock.length > 0){
				parentBlock[0].scrollIntoView();
			}else{
				panel[0].scrollIntoView();
			}
		}
	};

	Smc.Scorm.setScormScore = function (clock) {
		var currentFeedback = null;
		var blockId = clock.data('blockId');
		var panel = $("#" + blockId);
		var testObject = clock.data("testObject");
		if(testObject != null){
			var feedbacks = panel.children(".feedback[data-is-default!='true'][data-to-include!='true']");
			var totalWrongs = testObject.errorCount;
			for (var i = 0; i < feedbacks.length; i++) {
				var feedback = feedbacks[i];
				var currentWrongs = $(currentFeedback).data("wrongTrials") ? $(currentFeedback).data("wrongTrials") : null;
				if($(feedback).data("wrongTrials") >= totalWrongs && (currentWrongs == null || $(feedback).data("wrongTrials") <= currentWrongs) ){
					currentFeedback = feedback;
					if ($(feedback).data("wrongTrials") === totalWrongs) {
						break;
					}
				}
			}
		}
		if (SCOSetScore){
			if(maxWrongAnsw = ''){
				SCOSetScore(blockId, true);
			}else{
				SCOSetScore(blockId, wrongAnsw < clock.data("wrongTrials") ? true : false);
			}
		}
	};

	function saveTestState() {
		var testState = getCookie('testState');
		var newTestState = 1;
		if(testState){
			newTestState = Number(testState) + 1;
		}
		setCookie("testState", newTestState, 7);
	}

	function initMultipleChoice() {

		$(".submit-mc-answer").click(testResponse);
		var blockId = $(".submit-mc-answer").closest('article').attr('id');
		checkTimer(blockId);
		getSummary();
	}
	function testResponse() {
		var ct = $(this).parent().parent().find('.multipleChoiceForm');
		var answerAllQuestionsMsg = ct.find('.answerAllQuestionsMsg');
		var maxWrongAnswers = ct.data('maxWrongAnswers');
		var wrongAnswers = ct.data('wrongAnswers');
		var notAnswered = false;
		var checkType = ct.data('type');
		var questionID = ct.data('questionId');
		var testObject = {};

		answerAllQuestionsMsg.hide();

		var inputs = $("input", ct); //document.getElementsByTagName("input");

		var list = new Array(inputs.length);

		for (var i = 0; i < inputs.length; i++) {
			var id = inputs[i].name;
			if (id.substring(0, 2) == "Q_") {
				if (inputs[i].checked) {
					list[id] = "true";
				}
				else {
					if (list[id] != "true")
						list[id] = "false";
				}
			}
		}

		var counter = allCounter = falseCounter = correctCounter = totalCounter = 0;

		for (var id in list) {
			var obj_id = id.substr(2);
			var obj = document.getElementById(obj_id);
			obj.className = "";
			if (list[id] == "false") {
				counter++;
				if (!checkType) {
					obj.className = "notAnswered";
					notAnswered = true;
				}
			}
		}

		if (notAnswered == true && !checkType) {
			answerAllQuestionsMsg.show();
			return;
		}

		var incorrect = false;

		for (var id in list) {
			var obj_id = id.substr(2);
			var obj = $("#" + obj_id);

			allCounter++;

			if (check(obj_id)) {
				correctCounter++;
			}
			else {
				incorrect = true;
				falseCounter++;
				//ct.attr("data-wrong-answers", totalCounter);
			}

		}

		testObject.questionID = questionID;

		if (incorrect) {
			totalCounter=Number(wrongAnswers) + 1;
			testObject.errorCount = totalCounter;

			ct.data('wrongAnswers',totalCounter);
			$("#counter-"+questionID).html(totalCounter);

			if (maxWrongAnswers == totalCounter) {
				for (var id in list) {
					var obj_id = id.substr(2);
					var obj = $("#" + obj_id);
					var obj_false = $("#Expl_" + obj_id);
					var obj_correct = $("#Expl_" + obj_id + "_Correct");

					if (check(obj_id)) {
						obj.parent().addClass("correctAnswered");
						obj_correct.show();
					}
					else {
						obj_false.show();
						obj.parent().addClass("failAnswered");
					}

				}
				testObject.finished = true;
				testObject.excerciseFinished = true;
				testObject.aproved = false;
				$(this).hide();
			}

		} else {
			for (var id in list) {
				var obj_id = id.substr(2);
				var obj = $("#" + obj_id);
				var obj_correct = $("#Expl_" + obj_id + "_Correct");

				if (check(obj_id)) {
					obj.parent().addClass("correctAnswered");
					obj_correct.show();
				}

			}
			testObject.finished = true;
			testObject.excerciseFinished = true;
			testObject.aproved = true;
			$(this).hide();
		}

		maxWrongAnsw = ct.data('maxWrongAnswers');
		wrongAnsw = ct.data('wrongAnswers');

		Smc.Scorm.interactionEnd(testObject);
	}

	function check(id) {
		var chosenAnswer = $("input[name=Q_" + id + "]:checked").val();
		if (chosenAnswer == undefined) {
			chosenAnswer = "false";
		}
		var answer = $("#Answer_" + id).text();
		return chosenAnswer == answer;
	}

	function timeOff(clock) {
		Smc.Scorm.showFeedback(clock,true);
		//Smc.Scorm.interactionEnd();
	};

	$('#clock .clock_ico').click(function(e){
		$(this).parent().parent().toggleClass("hiddenClock");
	});

	$('a').on('click', function(e, data){
		if(window.isTesting && !$(this).hasClass("collapsed") && !$(this).hasClass("infoButton") && !$(this).hasClass("popup")){
			e.preventDefault();
			window.activatedLink = this.href;
			openTestingModal(this, acceptLink);
			return false;
		}
	});

	function openTestingModal(scope, callback){
		var modal = $('#testing-modal');
		var fClose = function(){
			modal.modal("hide");
		}
		modal.modal("show");
		$("#endTesting").unbind().one('click', {scope: scope}, callback).one('click', fClose);
	}
	function acceptLink(){
		window.location.href = window.activatedLink;
	}
});



